Gecode::Int::ViewValGraph::ViewNode< View > Class Template Reference

View nodes in view-value graph. More...

`#include <view-val-graph.hh>`

## Public Member Functions

| ViewNode (void)
| Initialize node for a non-view.
| ViewNode (View x)
| Initialize new node for view x.
Edge< View > * | val_edges (void) const
| Return first edge of all value edges.
Edge< View > ** | val_edges_ref (void)
| Return pointer to first edge fields of all value edges.
bool | fake (void) const
| Test whether node has a fake view.
View | view (void) const
| Return view.
void | update (void)
| Update size of view after change.
bool | changed (void) const
| Return whether view has changed its size.
bool | matched (void) const
| Whether the node is matched.
Public Member Functions inherited from Gecode::Int::ViewValGraph::Node< View >
| Node (void)
| Initialize.
Edge< View > * | edge_fst (void) const
| Return first edge (organized by bi-links).
Edge< View > * | edge_lst (void) const
| Return last edge (organized by bi-links).
Public Member Functions inherited from Gecode::Int::ViewValGraph::BiLink
| BiLink (void)
| Initialize as empty (self referenced).
BiLink * | prev (void) const
| Return previous element.
BiLink * | next (void) const
| Return next element.
void | prev (BiLink *l)
| Set previous element to l.
void | next (BiLink *l)
| Set next element to l.
void | add (BiLink *l)
| Add l after this element.
void | unlink (void)
| Unlink this element.
void | mark (void)
| Mark element (invalidates next element pointer).
bool | marked (void) const
| Whether element is marked.
bool | empty (void) const
| Whether element has no previous and next element.

## Protected Attributes

unsigned int | _size
| The size of the view after last change.
View | _view
| The node's view.
Edge< View > * | _val_edges
| The first value edge.

## Additional Inherited Members

Static Public Member Functions inherited from Gecode::Int::ViewValGraph::Node< View >
static void * | operator new (size_t, Space &)
| Allocate memory from space.
static void | operator delete (void *, size_t)
| Needed for exceptions.
static void | operator delete (void *, Space &)
| Needed for exceptions.
Public Attributes inherited from Gecode::Int::ViewValGraph::Node< View >
Edge< View > * | iter
| Next edge for computing strongly connected components.
unsigned int | low
| Values for computing strongly connected components.
unsigned int | min
unsigned int | comp

## Detailed Description

template<class View>
class Gecode::Int::ViewValGraph::ViewNode< View >

View nodes in view-value graph.

Definition at line 174 of file view-val-graph.hh.

## Constructor & Destructor Documentation

## ViewNode() [1/2]

template<class View>

Gecode::Int::ViewValGraph::ViewNode< View >::ViewNode | ( | void |  | ) |

inline

Initialize node for a non-view.

Definition at line 122 of file node.hpp.

## ViewNode() [2/2]

template<class View>

Gecode::Int::ViewValGraph::ViewNode< View >::ViewNode | ( | View | x | ) |

inline

Initialize new node for view x.

Definition at line 126 of file node.hpp.

## Member Function Documentation

## val_edges()

template<class View>

Edge< View > * Gecode::Int::ViewValGraph::ViewNode< View >::val_edges | ( | void |  | ) | const

inline

Return first edge of all value edges.

Definition at line 130 of file node.hpp.

## val_edges_ref()

template<class View>

Edge< View > ** Gecode::Int::ViewValGraph::ViewNode< View >::val_edges_ref | ( | void |  | ) |

inline

Return pointer to first edge fields of all value edges.

Definition at line 135 of file node.hpp.

## fake()

template<class View>

bool Gecode::Int::ViewValGraph::ViewNode< View >::fake | ( | void |  | ) | const

inline

Test whether node has a fake view.

Definition at line 140 of file node.hpp.

## view()

template<class View>

View Gecode::Int::ViewValGraph::ViewNode< View >::view | ( | void |  | ) | const

inline

Return view.

Definition at line 145 of file node.hpp.

## update()

template<class View>

void Gecode::Int::ViewValGraph::ViewNode< View >::update | ( | void |  | ) |

inline

Update size of view after change.

Definition at line 155 of file node.hpp.

## changed()

template<class View>

bool Gecode::Int::ViewValGraph::ViewNode< View >::changed | ( | void |  | ) | const

inline

Return whether view has changed its size.

Definition at line 150 of file node.hpp.

## matched()

template<class View>

bool Gecode::Int::ViewValGraph::ViewNode< View >::matched | ( | void |  | ) | const

inline

Whether the node is matched.

Definition at line 160 of file node.hpp.

## Member Data Documentation

## _size

template<class View>

unsigned int Gecode::Int::ViewValGraph::ViewNode< View >::_size

protected

The size of the view after last change.

Definition at line 177 of file view-val-graph.hh.

## _view

template<class View>

View Gecode::Int::ViewValGraph::ViewNode< View >::_view

protected

The node's view.

Definition at line 179 of file view-val-graph.hh.

## _val_edges

template<class View>

Edge<View>* Gecode::Int::ViewValGraph::ViewNode< View >::_val_edges

protected

The first value edge.

Definition at line 181 of file view-val-graph.hh.

The documentation for this class was generated from the following files:

- gecode/int/view-val-graph.hh
- gecode/int/view-val-graph/node.hpp